// RubyIndentvOC indent.js
// @date 2014.4.12 takeharu v0.1
// @note ^Cvʐݒ[Cfg]Ƀ`FbNĉ

//J[\̂sԍ
var cPressed   = Indent.GetChar();
var nCurLine   = parseInt(Editor.ExpandParameter("$y"));
var nCurColumn = parseInt(Editor.ExpandParameter("$x"));
var sCurLine   = Editor.GetLineStr( nCurLine );
var sPreLine = ""
if(nCurLine>1){
	sPreLine = Editor.GetLineStr( nCurLine-1 );
}

//Cfg̍쐬
var bTabIndent = Plugin.GetOption("Indent", "SpaceIndent") == 1 ? true : false;
var indentUnit = "";
if (!bTabIndent) {
	indentUnit = "\t";
} else {
	var nTabSize = Editor.ChangeTabWidth( 0 );
	for (var i=0; i<nTabSize; i++) {
		indentUnit += " ";
	}
}
//^O̍쐬
var bTabClose = Plugin.GetOption("Indent", "InsertClose") == 1 ? true : false;
//End`̃IvV
var bReIndentEnd = Plugin.GetOption("Indent", "AlignClose") == 1 ? true : false;

//poRegexPreCompile
var reSp=/^[ \t]*/
//CfgΏۂƂ̕^ÕyA
var closingChars = [
	[/^.*\{/         ,'\}'],
	[/^.*\(/         ,'\)'],
	[/^.*\[/         ,'\]'],
	[/^.*\brescue\b/ ,''],
	[/^\s*\bif\b/    ,'end'],
	[/^\s*\bunless\b/,'end'],
	[/^.*\bclass\b/  ,'end'],
	[/^.*\bdef\b/    ,'end'],
	[/^.*\bdo\b/     ,'end'],
	[/^.*\bbegin\b/  ,'end']
];
/*
TraceOut(''
	+' rw:'+nCurLine.toString()
);
*/

if (cPressed == '\r') {	//sCfg
//	Editor.InsText( sPreLine.match(/^[ \t]*/) );
//	preSplit=sPreLine.split(' ');

	for( i in closingChars){
		key=closingChars[i];
		re= key[0];
		if(re.test(sPreLine)){
			cChar = key[1];
			if(!cChar)Editor.InsText( indentUnit );
			if(RegExp.rightContext.indexOf(cChar)==-1){
				if (bTabClose) {
					Editor.MoveHistSet();
					Editor.Char(13);
					Editor.InsText( cChar );
					Editor.MoveHistPrev();
				}
				Editor.InsText( indentUnit );
			}
		}
	}
}
function rapen_word(echr,ere){
	if (cPressed == echr) {
		if(ere.test(sCurLine)){
			c=1;
			for (i = nCurLine-1; i > 0; i--) {
				tmp=Editor.GetLineStr( i );
				if(/(\b(do|begin)\b)|(^\s*(if|unless|class|def)\b)/.test(tmp)){c--;}
				if(/\bend\b/.test(tmp)){c++;}
				if(c<=0){
					lstr=sCurLine.slice(0,nCurColumn-1);
					sstr=tmp.match(reSp)[0];
					Editor.LineDeleteToStart ();
					Editor.InsText( lstr.replace(reSp, sstr) );
					break;
				}
			}
		}
	}
}
function rapen_char(bchr,echr){
	if (cPressed == echr) {
		//if(/^\s*\}/.test(sCurLine)){
		c=0;
		for (i = nCurLine; i > 0; i--) {
			tmp=Editor.GetLineStr( i );
			nb=tmp.split(bchr).length;
			ne=tmp.split(echr).length;
			c=c+ne-nb;
			if(c<=0){
				lstr=sCurLine.slice(0,nCurColumn-1);
				sstr=tmp.match(reSp)[0];
				Editor.LineDeleteToStart ();
				Editor.InsText( lstr.replace(reSp, sstr) );
				break;
			}
		}
	}
}
if (bReIndentEnd) {
	rapen_word('e',/^\s*rescue\b/);
	rapen_word('d',/^\s*end\b/);
	rapen_char('\(','\)');
	rapen_char('\{','\}');
	rapen_char('\[','\]');
}

if (cPressed == ' ') {	//R[hXjybg
}
